(set-logic QF_ABV)

; ------[ All vars declaration for entry machine state n°0 ]------
(declare-fun memory0 () (Array (_ BitVec 32) (_ BitVec 8)))
(declare-fun eax0 () (_ BitVec 32))
(declare-fun ebx0 () (_ BitVec 32))
(declare-fun ecx0 () (_ BitVec 32))
(declare-fun edx0 () (_ BitVec 32))
(declare-fun esi0 () (_ BitVec 32))
(declare-fun edi0 () (_ BitVec 32))
(declare-fun ebp0 () (_ BitVec 32))
(declare-fun esp0 () (_ BitVec 32))
(declare-fun OF0 () (_ BitVec 1))
(declare-fun SF0 () (_ BitVec 1))
(declare-fun ZF0 () (_ BitVec 1))
(declare-fun PF0 () (_ BitVec 1))
(declare-fun CF0 () (_ BitVec 1))
(declare-fun AF0 () (_ BitVec 1))
(declare-fun DF0 () (_ BitVec 1))
(assert (= esp0 (_ bv65536 32)))
(assert (= ebp0 (_ bv65536 32)))
(assert (= DF0 (_ bv0 1)))
(assert (= (select memory0 (_ bv8172 32)) (_ bv96 8)))
(assert (= (select memory0 (_ bv8173 32)) (_ bv32 8)))
(assert (= (select memory0 (_ bv8174 32)) (_ bv0 8)))
(assert (= (select memory0 (_ bv8175 32)) (_ bv0 8)))

; ------[ All vars declaration for entry BB 0x6cf -- [call_stack: Ø] -- [loops: Ø] ]------
(declare-fun memory1 () (Array (_ BitVec 32) (_ BitVec 8)))
(declare-fun eax1 () (_ BitVec 32))
(declare-fun ebx1 () (_ BitVec 32))
(declare-fun ecx1 () (_ BitVec 32))
(declare-fun edx1 () (_ BitVec 32))
(declare-fun esi1 () (_ BitVec 32))
(declare-fun edi1 () (_ BitVec 32))
(declare-fun ebp1 () (_ BitVec 32))
(declare-fun esp1 () (_ BitVec 32))
(declare-fun OF1 () (_ BitVec 1))
(declare-fun SF1 () (_ BitVec 1))
(declare-fun ZF1 () (_ BitVec 1))
(declare-fun PF1 () (_ BitVec 1))
(declare-fun CF1 () (_ BitVec 1))
(declare-fun AF1 () (_ BitVec 1))
(declare-fun DF1 () (_ BitVec 1))

; ------[ Disjunction of machine states for entry BB 0x6cf -- [call_stack: Ø] -- [loops: Ø] ]------
(assert (and (= memory1 memory0) (= eax1 eax0) (= ebx1 ebx0) (= ecx1 ecx0) (= edx1 edx0) (= esi1 esi0) (= edi1 edi0) (= ebp1 ebp0) (= esp1 esp0) (= OF1 OF0) (= SF1 SF0) (= ZF1 ZF0) (= PF1 PF0) (= CF1 CF0) (= AF1 AF0) (= DF1 DF0)))

; ------[ Formula BB 0x6cf -- [call_stack: Ø] -- [loops: Ø] ]------

; ------[ 0x6cf: call 0x6f9 (sym.__x86.get_pc_thunk.ax) ]------
(define-fun esp2 () (_ BitVec 32) (bvsub esp1 (_ bv4 32)))
(define-fun memory2 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory1 esp2 (_ bv212 8)) (bvadd esp2 (_ bv1 32)) (_ bv6 8)) (bvadd esp2 (_ bv2 32)) (_ bv0 8)) (bvadd esp2 (_ bv3 32)) (_ bv0 8)))

; ------[ Link 0x6cf -- [call_stack: Ø] -- [loops: Ø] --> 0x6f9 -- [call_stack: 0x6d4; ] -- [loops: Ø] ]------

; ------[ Formula BB 0x6f9 -- [call_stack: 0x6d4; ] -- [loops: Ø] ]------

; ------[ 0x6f9: mov eax, dword [esp] ]------
(define-fun eax2 () (_ BitVec 32) (concat (select memory2 (bvadd esp2 (_ bv3 32))) (concat (select memory2 (bvadd esp2 (_ bv2 32))) (concat (select memory2 (bvadd esp2 (_ bv1 32))) (select memory2 esp2)))))

; ------[ 0x6fc: ret ]------
(define-fun esp3 () (_ BitVec 32) (bvadd esp2 (_ bv4 32)))
(define-fun jumplocationexpr0 () (_ BitVec 32) (concat (select memory2 (bvsub esp3 (_ bv1 32))) (concat (select memory2 (bvsub esp3 (_ bv2 32))) (concat (select memory2 (bvsub esp3 (_ bv3 32))) (select memory2 (bvsub esp3 (_ bv4 32)))))))

; ------[ Link 0x6f9 -- [call_stack: 0x6d4; ] -- [loops: Ø] --> 0x6d4 -- [call_stack: Ø] -- [loops: Ø] ]------

; ------[ Formula BB 0x6d4 -- [call_stack: Ø] -- [loops: Ø] ]------

; ------[ 0x6d4: add eax, 0x192c ]------
(define-fun res320 () (_ BitVec 32) (bvadd eax2 (_ bv6444 32)))
(define-fun OF2 () (_ BitVec 1) (bvand (bvcomp ((_ extract 31 31) eax2) (_ bv0 1)) (bvnot (bvcomp ((_ extract 31 31) eax2) ((_ extract 31 31) res320)))))
(define-fun SF2 () (_ BitVec 1) (ite (bvslt res320 (_ bv0 32)) (_ bv1 1) (_ bv0 1)))
(define-fun ZF2 () (_ BitVec 1) (bvcomp res320 (_ bv0 32)))
(define-fun AF2 () (_ BitVec 1) ((_ extract 4 4) (bvadd ((_ zero_extend 1) ((_ extract 3 0) eax2)) (_ bv12 5))))
(define-fun PF2 () (_ BitVec 1) (bvnot (bvxor (bvxor (bvxor (bvxor (bvxor (bvxor (bvxor ((_ extract 0 0) res320) ((_ extract 1 1) res320)) ((_ extract 2 2) res320)) ((_ extract 3 3) res320)) ((_ extract 4 4) res320)) ((_ extract 5 5) res320)) ((_ extract 6 6) res320)) ((_ extract 7 7) res320))))
(define-fun CF2 () (_ BitVec 1) ((_ extract 32 32) (bvadd ((_ zero_extend 1) eax2) (_ bv6444 33))))
(define-fun eax3 () (_ BitVec 32) res320)

; ------[ 0x6d9: lea edx, [eax + 0x1f4] ]------
(define-fun edx2 () (_ BitVec 32) (bvadd eax3 (_ bv500 32)))

; ------[ 0x6df: mov dword [edx], 0 ]------
(define-fun memory3 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory2 edx2 (_ bv0 8)) (bvadd edx2 (_ bv1 32)) (_ bv0 8)) (bvadd edx2 (_ bv2 32)) (_ bv0 8)) (bvadd edx2 (_ bv3 32)) (_ bv0 8)))

; ------[ 0x6e5: push dword [eax - 0x14] ]------
(define-fun memory4 () (Array (_ BitVec 32) (_ BitVec 8)) (let ((elt_3962f927   (concat (select memory3 (bvsub eax3 (_ bv17 32)))   (concat (select memory3 (bvsub eax3 (_ bv18 32)))   (concat (select memory3 (bvsub eax3 (_ bv19 32)))   (select memory3 (bvsub eax3 (_ bv20 32)))))))) (store (store (store (store memory3 (bvsub esp3 (_ bv4 32)) ((_ extract 7 0) elt_3962f927)) (bvsub esp3 (_ bv3 32)) ((_ extract 15 8) elt_3962f927)) (bvsub esp3 (_ bv2 32)) ((_ extract 23 16) elt_3962f927)) (bvsub esp3 (_ bv1 32)) ((_ extract 31 24) elt_3962f927))))
(define-fun esp4 () (_ BitVec 32) (bvsub esp3 (_ bv4 32)))

; ------[ 0x6eb: call 0x6b4 (sym.Test) ]------
(define-fun esp5 () (_ BitVec 32) (bvsub esp4 (_ bv4 32)))
(define-fun memory5 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory4 esp5 (_ bv240 8)) (bvadd esp5 (_ bv1 32)) (_ bv6 8)) (bvadd esp5 (_ bv2 32)) (_ bv0 8)) (bvadd esp5 (_ bv3 32)) (_ bv0 8)))

; ------[ Link 0x6d4 -- [call_stack: Ø] -- [loops: Ø] --> 0x6b4 -- [call_stack: 0x6f0; ] -- [loops: Ø] ]------

; ------[ Formula BB 0x6b4 -- [call_stack: 0x6f0; ] -- [loops: Ø] ]------

; ------[ 0x6b4: push ebx ]------
(define-fun memory6 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory5 (bvsub esp5 (_ bv4 32)) ((_ extract 7 0) ebx1)) (bvsub esp5 (_ bv3 32)) ((_ extract 15 8) ebx1)) (bvsub esp5 (_ bv2 32)) ((_ extract 23 16) ebx1)) (bvsub esp5 (_ bv1 32)) ((_ extract 31 24) ebx1)))
(define-fun esp6 () (_ BitVec 32) (bvsub esp5 (_ bv4 32)))

; ------[ 0x6b5: mov ebx, dword [esp + 8] ]------
(define-fun ebx2 () (_ BitVec 32) (concat (select memory6 (bvadd esp6 (_ bv11 32))) (concat (select memory6 (bvadd esp6 (_ bv10 32))) (concat (select memory6 (bvadd esp6 (_ bv9 32))) (select memory6 (bvadd esp6 (_ bv8 32)))))))

; ------[ 0x6b9: push ebx ]------
(define-fun memory7 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory6 (bvsub esp6 (_ bv4 32)) ((_ extract 7 0) ebx2)) (bvsub esp6 (_ bv3 32)) ((_ extract 15 8) ebx2)) (bvsub esp6 (_ bv2 32)) ((_ extract 23 16) ebx2)) (bvsub esp6 (_ bv1 32)) ((_ extract 31 24) ebx2)))
(define-fun esp7 () (_ BitVec 32) (bvsub esp6 (_ bv4 32)))

; ------[ 0x6ba: call 0x685 (sym.Initialize) ]------
(define-fun esp8 () (_ BitVec 32) (bvsub esp7 (_ bv4 32)))
(define-fun memory8 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory7 esp8 (_ bv191 8)) (bvadd esp8 (_ bv1 32)) (_ bv6 8)) (bvadd esp8 (_ bv2 32)) (_ bv0 8)) (bvadd esp8 (_ bv3 32)) (_ bv0 8)))

; ------[ Link 0x6b4 -- [call_stack: 0x6f0; ] -- [loops: Ø] --> 0x685 -- [call_stack: 0x6f0; 0x6bf; ] -- [loops: Ø] ]------

; ------[ Formula BB 0x685 -- [call_stack: 0x6f0; 0x6bf; ] -- [loops: Ø] ]------

; ------[ 0x685: push edi ]------
(define-fun memory9 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory8 (bvsub esp8 (_ bv4 32)) ((_ extract 7 0) edi1)) (bvsub esp8 (_ bv3 32)) ((_ extract 15 8) edi1)) (bvsub esp8 (_ bv2 32)) ((_ extract 23 16) edi1)) (bvsub esp8 (_ bv1 32)) ((_ extract 31 24) edi1)))
(define-fun esp9 () (_ BitVec 32) (bvsub esp8 (_ bv4 32)))

; ------[ 0x686: push esi ]------
(define-fun memory10 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory9 (bvsub esp9 (_ bv4 32)) ((_ extract 7 0) esi1)) (bvsub esp9 (_ bv3 32)) ((_ extract 15 8) esi1)) (bvsub esp9 (_ bv2 32)) ((_ extract 23 16) esi1)) (bvsub esp9 (_ bv1 32)) ((_ extract 31 24) esi1)))
(define-fun esp10 () (_ BitVec 32) (bvsub esp9 (_ bv4 32)))

; ------[ 0x687: push ebx ]------
(define-fun memory11 () (Array (_ BitVec 32) (_ BitVec 8)) (store (store (store (store memory10 (bvsub esp10 (_ bv4 32)) ((_ extract 7 0) ebx2)) (bvsub esp10 (_ bv3 32)) ((_ extract 15 8) ebx2)) (bvsub esp10 (_ bv2 32)) ((_ extract 23 16) ebx2)) (bvsub esp10 (_ bv1 32)) ((_ extract 31 24) ebx2)))
(define-fun esp11 () (_ BitVec 32) (bvsub esp10 (_ bv4 32)))

; ------[ 0x688: mov edi, dword [esp + 0x10] ]------
(define-fun edi2 () (_ BitVec 32) (concat (select memory11 (bvadd esp11 (_ bv19 32))) (concat (select memory11 (bvadd esp11 (_ bv18 32))) (concat (select memory11 (bvadd esp11 (_ bv17 32))) (select memory11 (bvadd esp11 (_ bv16 32)))))))

; ------[ 0x68c: mov ebx, edi ]------
(define-fun ebx3 () (_ BitVec 32) edi2)

; ------[ 0x68e: add edi, 0x190 ]------
(define-fun res321 () (_ BitVec 32) (bvadd edi2 (_ bv400 32)))
(define-fun OF3 () (_ BitVec 1) (bvand (bvcomp ((_ extract 31 31) edi2) (_ bv0 1)) (bvnot (bvcomp ((_ extract 31 31) edi2) ((_ extract 31 31) res321)))))
(define-fun SF3 () (_ BitVec 1) (ite (bvslt res321 (_ bv0 32)) (_ bv1 1) (_ bv0 1)))
(define-fun ZF3 () (_ BitVec 1) (bvcomp res321 (_ bv0 32)))
(define-fun AF3 () (_ BitVec 1) (_ bv0 1))
(define-fun PF3 () (_ BitVec 1) (bvnot (bvxor (bvxor (bvxor (bvxor (bvxor (bvxor (bvxor ((_ extract 0 0) res321) ((_ extract 1 1) res321)) ((_ extract 2 2) res321)) ((_ extract 3 3) res321)) ((_ extract 4 4) res321)) ((_ extract 5 5) res321)) ((_ extract 6 6) res321)) ((_ extract 7 7) res321))))
(define-fun CF3 () (_ BitVec 1) ((_ extract 32 32) (bvadd ((_ zero_extend 1) edi2) (_ bv400 33))))
(define-fun edi3 () (_ BitVec 32) res321)

; ------[ 0x694: lea esi, [ebx + 0x28] ]------
(define-fun esi2 () (_ BitVec 32) (bvadd ebx3 (_ bv40 32)))

(check-sat)

(get-value (esi2))